unit schComisionesClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDAInterfaces, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Facturas_Comision = '{69C6A9C2-1439-4AAC-9471-8B3FB42EDFE3}';
  RID_Comisiones = '{81E932F0-7BF0-4C1D-A22F-2FED176FD36A}';
  RID_V_Detalles_Facturas_Comision = '{C60C13FF-26D0-444D-85A3-03DC05AAB574}';

  { Data table names }
  nme_Facturas_Comision = 'Facturas_Comision';
  nme_Comisiones = 'Comisiones';
  nme_V_Detalles_Facturas_Comision = 'V_Detalles_Facturas_Comision';

  { Facturas_Comision fields }
  fld_Facturas_ComisionID_EMPRESA = 'ID_EMPRESA';
  fld_Facturas_ComisionID_AGENTE = 'ID_AGENTE';
  fld_Facturas_ComisionAGENTE = 'AGENTE';
  fld_Facturas_ComisionID_FACTURA = 'ID_FACTURA';
  fld_Facturas_ComisionID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_Facturas_ComisionFECHA = 'FECHA';
  fld_Facturas_ComisionREFERENCIA = 'REFERENCIA';
  fld_Facturas_ComisionSITUACION = 'SITUACION';
  fld_Facturas_ComisionID_CLIENTE = 'ID_CLIENTE';
  fld_Facturas_ComisionCLIENTE = 'CLIENTE';
  fld_Facturas_ComisionID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_Facturas_ComisionPROVEEDOR = 'PROVEEDOR';
  fld_Facturas_ComisionCOMISION = 'COMISION';
  fld_Facturas_ComisionIMPORTE_COMISIONABLE = 'IMPORTE_COMISIONABLE';
  fld_Facturas_ComisionIMPORTE_COMISION = 'IMPORTE_COMISION';

  { Facturas_Comision field indexes }
  idx_Facturas_ComisionID_EMPRESA = 0;
  idx_Facturas_ComisionID_AGENTE = 1;
  idx_Facturas_ComisionAGENTE = 2;
  idx_Facturas_ComisionID_FACTURA = 3;
  idx_Facturas_ComisionID_COMISION_LIQUIDADA = 4;
  idx_Facturas_ComisionFECHA = 5;
  idx_Facturas_ComisionREFERENCIA = 6;
  idx_Facturas_ComisionSITUACION = 7;
  idx_Facturas_ComisionID_CLIENTE = 8;
  idx_Facturas_ComisionCLIENTE = 9;
  idx_Facturas_ComisionID_PROVEEDOR = 10;
  idx_Facturas_ComisionPROVEEDOR = 11;
  idx_Facturas_ComisionCOMISION = 12;
  idx_Facturas_ComisionIMPORTE_COMISIONABLE = 13;
  idx_Facturas_ComisionIMPORTE_COMISION = 14;

  { Comisiones fields }
  fld_ComisionesID = 'ID';
  fld_ComisionesID_EMPRESA = 'ID_EMPRESA';
  fld_ComisionesREFERENCIA = 'REFERENCIA';
  fld_ComisionesID_AGENTE = 'ID_AGENTE';
  fld_ComisionesDESCRIPCION = 'DESCRIPCION';
  fld_ComisionesFECHA = 'FECHA';
  fld_ComisionesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_ComisionesUSUARIO = 'USUARIO';
  fld_ComisionesNOMBRE = 'NOMBRE';

  { Comisiones field indexes }
  idx_ComisionesID = 0;
  idx_ComisionesID_EMPRESA = 1;
  idx_ComisionesREFERENCIA = 2;
  idx_ComisionesID_AGENTE = 3;
  idx_ComisionesDESCRIPCION = 4;
  idx_ComisionesFECHA = 5;
  idx_ComisionesIMPORTE_TOTAL = 6;
  idx_ComisionesUSUARIO = 7;
  idx_ComisionesNOMBRE = 8;

  { V_Detalles_Facturas_Comision fields }
  fld_V_Detalles_Facturas_ComisionID_EMPRESA = 'ID_EMPRESA';
  fld_V_Detalles_Facturas_ComisionID_AGENTE = 'ID_AGENTE';
  fld_V_Detalles_Facturas_ComisionAGENTE = 'AGENTE';
  fld_V_Detalles_Facturas_ComisionID_FACTURA = 'ID_FACTURA';
  fld_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_V_Detalles_Facturas_ComisionFECHA = 'FECHA';
  fld_V_Detalles_Facturas_ComisionREFERENCIA = 'REFERENCIA';
  fld_V_Detalles_Facturas_ComisionSITUACION = 'SITUACION';
  fld_V_Detalles_Facturas_ComisionID_CLIENTE = 'ID_CLIENTE';
  fld_V_Detalles_Facturas_ComisionCLIENTE = 'CLIENTE';
  fld_V_Detalles_Facturas_ComisionID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_V_Detalles_Facturas_ComisionPROVEEDOR = 'PROVEEDOR';
  fld_V_Detalles_Facturas_ComisionCOMISION = 'COMISION';
  fld_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE = 'IMPORTE_COMISIONABLE';
  fld_V_Detalles_Facturas_ComisionIMPORTE_COMISION = 'IMPORTE_COMISION';

  { V_Detalles_Facturas_Comision field indexes }
  idx_V_Detalles_Facturas_ComisionID_EMPRESA = 0;
  idx_V_Detalles_Facturas_ComisionID_AGENTE = 1;
  idx_V_Detalles_Facturas_ComisionAGENTE = 2;
  idx_V_Detalles_Facturas_ComisionID_FACTURA = 3;
  idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA = 4;
  idx_V_Detalles_Facturas_ComisionFECHA = 5;
  idx_V_Detalles_Facturas_ComisionREFERENCIA = 6;
  idx_V_Detalles_Facturas_ComisionSITUACION = 7;
  idx_V_Detalles_Facturas_ComisionID_CLIENTE = 8;
  idx_V_Detalles_Facturas_ComisionCLIENTE = 9;
  idx_V_Detalles_Facturas_ComisionID_PROVEEDOR = 10;
  idx_V_Detalles_Facturas_ComisionPROVEEDOR = 11;
  idx_V_Detalles_Facturas_ComisionCOMISION = 12;
  idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE = 13;
  idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION = 14;

type
  { IFacturas_Comision }
  IFacturas_Comision = interface(IDAStronglyTypedDataTable)
  ['{C147ECB9-0DAF-46FD-B1F6-007A2D40E218}']
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetAGENTEValue: String;
    procedure SetAGENTEValue(const aValue: String);
    function GetAGENTEIsNull: Boolean;
    procedure SetAGENTEIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAIsNull: Boolean;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetCLIENTEValue: String;
    procedure SetCLIENTEValue(const aValue: String);
    function GetCLIENTEIsNull: Boolean;
    procedure SetCLIENTEIsNull(const aValue: Boolean);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetID_PROVEEDORIsNull: Boolean;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean);
    function GetPROVEEDORValue: String;
    procedure SetPROVEEDORValue(const aValue: String);
    function GetPROVEEDORIsNull: Boolean;
    procedure SetPROVEEDORIsNull(const aValue: Boolean);
    function GetCOMISIONValue: Float;
    procedure SetCOMISIONValue(const aValue: Float);
    function GetCOMISIONIsNull: Boolean;
    procedure SetCOMISIONIsNull(const aValue: Boolean);
    function GetIMPORTE_COMISIONABLEValue: Currency;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
    function GetIMPORTE_COMISIONABLEIsNull: Boolean;
    procedure SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean);
    function GetIMPORTE_COMISIONValue: Currency;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency);
    function GetIMPORTE_COMISIONIsNull: Boolean;
    procedure SetIMPORTE_COMISIONIsNull(const aValue: Boolean);


    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property AGENTEIsNull: Boolean read GetAGENTEIsNull write SetAGENTEIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CLIENTEIsNull: Boolean read GetCLIENTEIsNull write SetCLIENTEIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property PROVEEDORIsNull: Boolean read GetPROVEEDORIsNull write SetPROVEEDORIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISIONABLEIsNull: Boolean read GetIMPORTE_COMISIONABLEIsNull write SetIMPORTE_COMISIONABLEIsNull;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
    property IMPORTE_COMISIONIsNull: Boolean read GetIMPORTE_COMISIONIsNull write SetIMPORTE_COMISIONIsNull;
  end;

  { TFacturas_ComisionDataTableRules }
  TFacturas_ComisionDataTableRules = class(TDADataTableRules, IFacturas_Comision)
  private
  protected
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetAGENTEValue: String; virtual;
    procedure SetAGENTEValue(const aValue: String); virtual;
    function GetAGENTEIsNull: Boolean; virtual;
    procedure SetAGENTEIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAIsNull: Boolean; virtual;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetCLIENTEValue: String; virtual;
    procedure SetCLIENTEValue(const aValue: String); virtual;
    function GetCLIENTEIsNull: Boolean; virtual;
    procedure SetCLIENTEIsNull(const aValue: Boolean); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORIsNull: Boolean; virtual;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetPROVEEDORValue: String; virtual;
    procedure SetPROVEEDORValue(const aValue: String); virtual;
    function GetPROVEEDORIsNull: Boolean; virtual;
    procedure SetPROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetCOMISIONValue: Float; virtual;
    procedure SetCOMISIONValue(const aValue: Float); virtual;
    function GetCOMISIONIsNull: Boolean; virtual;
    procedure SetCOMISIONIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_COMISIONABLEValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONABLEIsNull: Boolean; virtual;
    procedure SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_COMISIONValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONIsNull: Boolean; virtual;
    procedure SetIMPORTE_COMISIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property AGENTEIsNull: Boolean read GetAGENTEIsNull write SetAGENTEIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CLIENTEIsNull: Boolean read GetCLIENTEIsNull write SetCLIENTEIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property PROVEEDORIsNull: Boolean read GetPROVEEDORIsNull write SetPROVEEDORIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISIONABLEIsNull: Boolean read GetIMPORTE_COMISIONABLEIsNull write SetIMPORTE_COMISIONABLEIsNull;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
    property IMPORTE_COMISIONIsNull: Boolean read GetIMPORTE_COMISIONIsNull write SetIMPORTE_COMISIONIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IComisiones }
  IComisiones = interface(IDAStronglyTypedDataTable)
  ['{08412911-08D5-4CB6-BD93-E55E146EB577}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetDESCRIPCIONIsNull: Boolean;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
  end;

  { TComisionesDataTableRules }
  TComisionesDataTableRules = class(TDADataTableRules, IComisiones)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IV_Detalles_Facturas_Comision }
  IV_Detalles_Facturas_Comision = interface(IDAStronglyTypedDataTable)
  ['{DF8D0894-2A3B-4713-86FE-C8B816CB3256}']
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetAGENTEValue: String;
    procedure SetAGENTEValue(const aValue: String);
    function GetAGENTEIsNull: Boolean;
    procedure SetAGENTEIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAIsNull: Boolean;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetCLIENTEValue: String;
    procedure SetCLIENTEValue(const aValue: String);
    function GetCLIENTEIsNull: Boolean;
    procedure SetCLIENTEIsNull(const aValue: Boolean);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetID_PROVEEDORIsNull: Boolean;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean);
    function GetPROVEEDORValue: String;
    procedure SetPROVEEDORValue(const aValue: String);
    function GetPROVEEDORIsNull: Boolean;
    procedure SetPROVEEDORIsNull(const aValue: Boolean);
    function GetCOMISIONValue: Float;
    procedure SetCOMISIONValue(const aValue: Float);
    function GetCOMISIONIsNull: Boolean;
    procedure SetCOMISIONIsNull(const aValue: Boolean);
    function GetIMPORTE_COMISIONABLEValue: Currency;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
    function GetIMPORTE_COMISIONABLEIsNull: Boolean;
    procedure SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean);
    function GetIMPORTE_COMISIONValue: Currency;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency);
    function GetIMPORTE_COMISIONIsNull: Boolean;
    procedure SetIMPORTE_COMISIONIsNull(const aValue: Boolean);


    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property AGENTEIsNull: Boolean read GetAGENTEIsNull write SetAGENTEIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CLIENTEIsNull: Boolean read GetCLIENTEIsNull write SetCLIENTEIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property PROVEEDORIsNull: Boolean read GetPROVEEDORIsNull write SetPROVEEDORIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISIONABLEIsNull: Boolean read GetIMPORTE_COMISIONABLEIsNull write SetIMPORTE_COMISIONABLEIsNull;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
    property IMPORTE_COMISIONIsNull: Boolean read GetIMPORTE_COMISIONIsNull write SetIMPORTE_COMISIONIsNull;
  end;

  { TV_Detalles_Facturas_ComisionDataTableRules }
  TV_Detalles_Facturas_ComisionDataTableRules = class(TDADataTableRules, IV_Detalles_Facturas_Comision)
  private
  protected
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetAGENTEValue: String; virtual;
    procedure SetAGENTEValue(const aValue: String); virtual;
    function GetAGENTEIsNull: Boolean; virtual;
    procedure SetAGENTEIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAIsNull: Boolean; virtual;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetCLIENTEValue: String; virtual;
    procedure SetCLIENTEValue(const aValue: String); virtual;
    function GetCLIENTEIsNull: Boolean; virtual;
    procedure SetCLIENTEIsNull(const aValue: Boolean); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORIsNull: Boolean; virtual;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetPROVEEDORValue: String; virtual;
    procedure SetPROVEEDORValue(const aValue: String); virtual;
    function GetPROVEEDORIsNull: Boolean; virtual;
    procedure SetPROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetCOMISIONValue: Float; virtual;
    procedure SetCOMISIONValue(const aValue: Float); virtual;
    function GetCOMISIONIsNull: Boolean; virtual;
    procedure SetCOMISIONIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_COMISIONABLEValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONABLEIsNull: Boolean; virtual;
    procedure SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_COMISIONValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONIsNull: Boolean; virtual;
    procedure SetIMPORTE_COMISIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property AGENTEIsNull: Boolean read GetAGENTEIsNull write SetAGENTEIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CLIENTEIsNull: Boolean read GetCLIENTEIsNull write SetCLIENTEIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property PROVEEDORIsNull: Boolean read GetPROVEEDORIsNull write SetPROVEEDORIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISIONABLEIsNull: Boolean read GetIMPORTE_COMISIONABLEIsNull write SetIMPORTE_COMISIONABLEIsNull;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
    property IMPORTE_COMISIONIsNull: Boolean read GetIMPORTE_COMISIONIsNull write SetIMPORTE_COMISIONIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TFacturas_ComisionDataTableRules }
constructor TFacturas_ComisionDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturas_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturas_ComisionDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_AGENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetAGENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionAGENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetAGENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionAGENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetAGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionAGENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetAGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionAGENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_FACTURA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_FACTURA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_FACTURA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_FACTURA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA].AsDateTime;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Facturas_ComisionFECHA].AsDateTime := aValue;
end;

function TFacturas_ComisionDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionFECHA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSITUACION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionSITUACION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetCLIENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCLIENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetCLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionCLIENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCLIENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetCLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionCLIENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetPROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetPROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetCOMISIONValue: Float;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCOMISION].AsFloat;
end;

procedure TFacturas_ComisionDataTableRules.SetCOMISIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_Facturas_ComisionCOMISION].AsFloat := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCOMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCOMISION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetCOMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionCOMISION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].AsVariant := Null;
end;


{ TComisionesDataTableRules }
constructor TComisionesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TComisionesDataTableRules.Destroy;
begin
  inherited;
end;

function TComisionesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID].AsInteger;
end;

procedure TComisionesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID].IsNull;
end;

procedure TComisionesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID].AsVariant := Null;
end;

function TComisionesDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID_EMPRESA].IsNull;
end;

procedure TComisionesDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID_EMPRESA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_ComisionesREFERENCIA].AsString;
end;

procedure TComisionesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesREFERENCIA].AsString := aValue;
end;

function TComisionesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesREFERENCIA].IsNull;
end;

procedure TComisionesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesREFERENCIA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID_AGENTE].IsNull;
end;

procedure TComisionesDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID_AGENTE].AsVariant := Null;
end;

function TComisionesDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_ComisionesDESCRIPCION].AsString;
end;

procedure TComisionesDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesDESCRIPCION].AsString := aValue;
end;

function TComisionesDataTableRules.GetDESCRIPCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesDESCRIPCION].IsNull;
end;

procedure TComisionesDataTableRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesDESCRIPCION].AsVariant := Null;
end;

function TComisionesDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_ComisionesFECHA].AsDateTime;
end;

procedure TComisionesDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ComisionesFECHA].AsDateTime := aValue;
end;

function TComisionesDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesFECHA].IsNull;
end;

procedure TComisionesDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesFECHA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsCurrency;
end;

procedure TComisionesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TComisionesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].IsNull;
end;

procedure TComisionesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsVariant := Null;
end;

function TComisionesDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_ComisionesUSUARIO].AsString;
end;

procedure TComisionesDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesUSUARIO].AsString := aValue;
end;

function TComisionesDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesUSUARIO].IsNull;
end;

procedure TComisionesDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesUSUARIO].AsVariant := Null;
end;

function TComisionesDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_ComisionesNOMBRE].AsString;
end;

procedure TComisionesDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesNOMBRE].AsString := aValue;
end;

function TComisionesDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesNOMBRE].IsNull;
end;

procedure TComisionesDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesNOMBRE].AsVariant := Null;
end;


{ TV_Detalles_Facturas_ComisionDataTableRules }
constructor TV_Detalles_Facturas_ComisionDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TV_Detalles_Facturas_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetAGENTEValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetAGENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetAGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetAGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].AsDateTime;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].AsDateTime := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCLIENTEValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetPROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetPROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCOMISIONValue: Float;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].AsFloat;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCOMISIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].AsFloat := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCOMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCOMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEValue: Currency;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].AsVariant := Null;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONValue: Currency;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].AsCurrency;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].AsCurrency := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].IsNull;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_Facturas_Comision, TFacturas_ComisionDataTableRules);
  RegisterDataTableRules(RID_Comisiones, TComisionesDataTableRules);
  RegisterDataTableRules(RID_V_Detalles_Facturas_Comision, TV_Detalles_Facturas_ComisionDataTableRules);

end.
